
Ruby - Bug #20743

ruby doesn't properly split RUBY_DEBUG_LOG_FILTER into items

09/15/2024 05:58 PM - x-yuri (Yuri Kanivetsky)

Status: Assigned   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version:    

ruby -v: ruby 3.4.0dev (2024-09-15T01:06:11Z

master 532af89e3b) +PRISM

[x86_64-linux-musl]

Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:

UNKNOWN

Description

$ docker run --rm alpine:3.20.3 sh -euxc '

    apk add git build-base autoconf ruby yaml-dev zlib-dev openssl-dev libffi-dev

    git clone https://github.com/ruby/ruby

    cd ruby

    git checkout 532af89e3b5b78dd3a6fe29c6cc64ad1b073afe2

    ./autogen.sh

    ./configure cflags=-DUSE_RUBY_DEBUG_LOG --disable-install-doc

    make -j8 install

    ruby -v

    RUBY_DEBUG_LOG=stderr RUBY_DEBUG_LOG_FILTER=rb_thread_schedule_limits,rb_ractor_thread_switch 

ruby -e ""

'

...

+ RUBY_DEBUG_LOG=stderr RUBY_DEBUG_LOG_FILTER=rb_thread_schedule_limits,rb_ractor_thread_switch ru

by -e     

RUBY_DEBUG_LOG=stderr [stderr]                                                                    

                                           

RUBY_DEBUG_LOG_FILTER[0]=rb_thread_schedule_limit (all)                                           

                                           

RUBY_DEBUG_LOG_FILTER[1]=rb_ractor_thread_switch (all)

...

 As you can see ruby reports that RUBY_DEBUG_LOG_FILTER[0] equals rb_thread_schedule_limit, not rb_thread_schedule_limits.

This happens because here:

https://github.com/ruby/ruby/blob/532af89e3b5b78dd3a6fe29c6cc64ad1b073afe2/debug.c#L353

1 should not be subtracted.

Also in the following lines str is increased, but len is not decreased. It makes sense to recheck if there are no further mistakes.

History

#1 - 09/15/2024 06:07 PM - x-yuri (Yuri Kanivetsky)

Apparently introduced in the following commit:

https://github.com/ruby/ruby/commit/5a4f997b2e8e819ed40731cd769826112072a9d4#diff-1cae4f3b0e13ea38a331366fa5370f5648b2c37090a19e8f

ba9b8e921c36f505R369

#2 - 10/17/2024 03:08 AM - hsbt (Hiroshi SHIBATA)

- Tags set to musl, alpine

#3 - 11/05/2024 06:45 AM - ko1 (Koichi Sasada)

- Assignee set to ko1 (Koichi Sasada)

#4 - 11/13/2024 05:16 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned

#5 - 01/28/2025 12:42 AM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/12642
